Index: trunk/src/VBox/HostServices/GuestControl/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/GuestControl/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/GuestControl/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2011 Oracle Corporation
+# Copyright (C) 2011-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -46,3 +46,3 @@
 	-install_name $(VBOX_DYLD_EXECUTABLE_PATH)/VBoxGuestControlSvc.dylib
 
-include $(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
Index: trunk/src/VBox/HostServices/GuestControl/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/GuestControl/testcase/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/GuestControl/testcase/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2010 Oracle Corporation
+# Copyright (C) 2010-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -44,4 +44,4 @@
 endif
 
-include $(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
 
Index: trunk/src/VBox/HostServices/GuestProperties/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/GuestProperties/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/GuestProperties/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 Oracle Corporation
+# Copyright (C) 2006-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -45,4 +45,4 @@
 	-install_name $(VBOX_DYLD_EXECUTABLE_PATH)/VBoxGuestPropSvc.dylib
 
-include $(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
 
Index: trunk/src/VBox/HostServices/GuestProperties/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/GuestProperties/testcase/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/GuestProperties/testcase/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 Oracle Corporation
+# Copyright (C) 2006-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -41,4 +41,4 @@
 endif
 
-include $(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
 
Index: trunk/src/VBox/HostServices/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2010 Oracle Corporation
+# Copyright (C) 2006-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -17,5 +17,5 @@
 
 SUB_DEPTH = ../../..
-include	$(KBUILD_PATH)/subheader.kmk
+include $(KBUILD_PATH)/subheader.kmk
 
 # Include sub-makefiles.
@@ -45,4 +45,4 @@
 include $(PATH_SUB_CURRENT)/testcase/Makefile.kmk
 
-include	$(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
 
Index: trunk/src/VBox/HostServices/SharedClipboard/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/SharedClipboard/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 Oracle Corporation
+# Copyright (C) 2006-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -88,3 +88,3 @@
 endif
 
-include $(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
Index: trunk/src/VBox/HostServices/SharedClipboard/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/testcase/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/SharedClipboard/testcase/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2011 Oracle Corporation
+# Copyright (C) 2011-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -31,3 +31,3 @@
 endif
 
-include $(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
Index: trunk/src/VBox/HostServices/SharedFolders/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/SharedFolders/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/SharedFolders/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 Oracle Corporation
+# Copyright (C) 2006-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -48,4 +48,4 @@
 	$(LIB_REM)
 
-include $(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
 
Index: trunk/src/VBox/HostServices/SharedFolders/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/SharedFolders/testcase/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/SharedFolders/testcase/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 Oracle Corporation
+# Copyright (C) 2006-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -87,4 +87,4 @@
 
 
-include $(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
 
Index: trunk/src/VBox/HostServices/SharedOpenGL/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/SharedOpenGL/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/SharedOpenGL/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2008-2010 Oracle Corporation
+# Copyright (C) 2008-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -17,5 +17,5 @@
 
 SUB_DEPTH = ../../../..
-include	$(KBUILD_PATH)/subheader.kmk
+include $(KBUILD_PATH)/subheader.kmk
 
 
@@ -149,5 +149,5 @@
 ifdef VBOX_WITH_CRHGSMI
 VBoxOGLcrserverlib_DEFS += ifdef VBOX_WITH_CRHGSMI
-endif 
+endif
 
 #
@@ -319,4 +319,4 @@
 endif
 
-include	$(KBUILD_PATH)/subfooter.kmk
-
+include $(FILE_KBUILD_SUB_FOOTER)
+
Index: trunk/src/VBox/HostServices/auth/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/auth/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/auth/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2010 Oracle Corporation
+# Copyright (C) 2006-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -61,4 +61,4 @@
 
 
-include $(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
 
Index: trunk/src/VBox/HostServices/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostServices/testcase/Makefile.kmk	(revision 41452)
+++ trunk/src/VBox/HostServices/testcase/Makefile.kmk	(revision 41477)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2009 Oracle Corporation
+# Copyright (C) 2009-2012 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -17,5 +17,5 @@
 
 SUB_DEPTH = ../../../..
-include	$(KBUILD_PATH)/subheader.kmk
+include $(KBUILD_PATH)/subheader.kmk
 
 if defined(VBOX_WITH_TESTCASES) && !defined(VBOX_ONLY_ADDITIONS) && !defined(VBOX_ONLY_SDK)
@@ -39,4 +39,4 @@
 endif # VBOX_WITH_TESTCASES
 
-include	$(KBUILD_PATH)/subfooter.kmk
+include $(FILE_KBUILD_SUB_FOOTER)
 